package exercises.ex_h2;

public class VehicleWithoutDeadlock implements Runnable {
    String name;
    private Bridge bridge;
    private Road road;

    public VehicleWithoutDeadlock(String name, Bridge bridge, Road road) {
        this.name = name;
        this.bridge = bridge;
        this.road = road;
    }

    @Override
    public void run() {
        // Do the actions to cross the bridge
        synchronized (bridge) {
            System.out.println(name + " is entering on the one-way bridge from " + road);
            try {
                Thread.sleep(100);
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
            System.out.println(name + " is leaving the one-way bridge");
        }
    }
}

